//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "About.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BMShapedForm"
#pragma link "TFlatButtonUnit"
#pragma link "htmlabel"
#pragma resource "*.dfm"
TUeberDialog *UeberDialog;
//---------------------------------------------------------------------------
__fastcall TUeberDialog::TUeberDialog(TComponent* Owner)
        : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 300, 200);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      MEMORYSTATUS ms;
   	  ms.dwLength = sizeof(MEMORYSTATUS);
   	  GlobalMemoryStatus(&ms);
	  Memory->Caption = (ms.dwTotalPhys/1024);
      FreeMemory->Caption = (ms.dwAvailPhys/1024);
      Label2->Caption = HauptFormular->Version->Caption;

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture2);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TUeberDialog::FlatButton13Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------
void __fastcall TUeberDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TUeberDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                UeberDialog->Left = UeberDialog->Left + ( X - FMoveX);
                UeberDialog->Top = UeberDialog->Top + ( Y - FMoveY);
                UeberDialog->Perform ( WM_PAINT,0,0 );
                HauptFormular->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------

void __fastcall TUeberDialog::FormCreate(TObject *Sender)
{
  TRegistry *Reg = new TRegistry;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Version", false))
    {
        Reg->ReadString("Version")==HauptFormular->Version->Caption;
        HauptFormular->ReadRegistry(Sender);
    }
  }
  __finally
  {
    Reg->CloseKey();
    delete Reg;
  }
}
//---------------------------------------------------------------------------

