//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Export.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TFlatButtonUnit"
#pragma resource "*.dfm"
TExportDialog *ExportDialog;
//---------------------------------------------------------------------------
__fastcall TExportDialog::TExportDialog(TComponent* Owner)
    : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 300, 200);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture2);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                ExportDialog->Left = ExportDialog->Left + ( X - FMoveX);
                ExportDialog->Top = ExportDialog->Top + ( Y - FMoveY);
                ExportDialog->Perform ( WM_PAINT,0,0 );
                HauptFormular->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::ExcelExportClick(TObject *Sender)
{
	if (SaveDialog->Execute())
	{
    	if (SaveDialog->FileName != EmptyStr)
        {
	    	SortDialog->WrapGrid1->SaveToXLS(SaveDialog->FileName);
    	}
    	else
    	{
    	}
	}
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::CSVExportClick(TObject *Sender)
{
	if (SaveDialog2->Execute())
	{
    	if (SaveDialog2->FileName != EmptyStr)
        {
	    	SortDialog->WrapGrid1->SaveToCSV(SaveDialog2->FileName);
    	}
    	else
    	{
    	}
	}
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::HTMLExportClick(TObject *Sender)
{
	if (SaveDialog1->Execute())
	{
    	if (SaveDialog1->FileName != EmptyStr)
        {
	    	SortDialog->WrapGrid1->SaveToHTML(SaveDialog1->FileName);
    	}
    	else
    	{
    	}
	}
}
//---------------------------------------------------------------------------
void __fastcall TExportDialog::FlatButton13Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------
