//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Formatierung.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ComboBoxPlus"
#pragma link "CSPIN"
#pragma link "TFlatComboBoxUnit"
#pragma link "TFlatButtonUnit"
#pragma link "BMShapedForm"
#pragma resource "*.dfm"
TFormatierungsDialog *FormatierungsDialog;
//---------------------------------------------------------------------------
__fastcall TFormatierungsDialog::TFormatierungsDialog(TComponent* Owner)
        : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 700, 250);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      if(FormatierungsDialog->ComboBox1->ItemIndex < 0)
      {
                FormatierungsDialog->ComboBox1->ItemIndex=0;
                FormatierungsDialog->ComboBox2->ItemIndex=1;
                FormatierungsDialog->ComboBox3->ItemIndex=2;
                FormatierungsDialog->ComboBox4->ItemIndex=7;
                FormatierungsDialog->ComboBox5->ItemIndex=7;
                FormatierungsDialog->ComboBox6->ItemIndex=7;
                FormatierungsDialog->ComboBox7->ItemIndex=1;
                FormatierungsDialog->ComboBox8->ItemIndex=0;
                FormatierungsDialog->ComboBox9->ItemIndex=0;
                FormatierungsDialog->FlatComboBox1->ItemIndex=0;
                FormatierungsDialog->FlatComboBox2->ItemIndex=7;
                FormatierungsDialog->FlatComboBox3->ItemIndex=6;
                FormatierungsDialog->FlatComboBox4->ItemIndex=7;
                FormatierungsDialog->FlatComboBox5->ItemIndex=5;
                FormatierungsDialog->FlatComboBox6->ItemIndex=7;
      }

/*
    delemiter[i]==0 -
    delemiter[i]==1 :
    delemiter[i]==2 *
    delemiter[i]==3 /
    delemiter[i]==4 \
    delemiter[i]==5 ()
    delemiter[i]==6 []
    delemiter[i]==7 none
*/
      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture3);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TFormatierungsDialog::OKButtonClick(TObject *Sender)
{
        HauptFormular->VorschauButtonClick(Sender);
        HauptFormular->WriteRegistry(Sender);
        Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormatierungsDialog::CancelButtonClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TFormatierungsDialog::ComboBox1Click(TObject *Sender)
{
        int testchoice[6];
        int testdelemiter[6];
        AnsiString test="";

        testchoice[0] = ComboBox1->ItemIndex;
        testchoice[1] = ComboBox2->ItemIndex;
        testchoice[2] = ComboBox3->ItemIndex;
        testchoice[3] = ComboBox4->ItemIndex;
        testchoice[4] = ComboBox5->ItemIndex;
        testchoice[5] = ComboBox6->ItemIndex;

        testdelemiter[0] = FlatComboBox1->ItemIndex;
        testdelemiter[1] = FlatComboBox2->ItemIndex;
        testdelemiter[2] = FlatComboBox3->ItemIndex;
        testdelemiter[3] = FlatComboBox4->ItemIndex;
        testdelemiter[4] = FlatComboBox5->ItemIndex;
        testdelemiter[5] = FlatComboBox6->ItemIndex;

        TestLabel->Caption = "";

        for (int i=0; i<6; i++)
        {
                switch (testchoice[i])
                {
                    case 0 :
                        if (OptionenDialog->Deutsch->Enabled==false || OptionenDialog->English->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Artist ";
                                    break;
                                    case 1 :
                                        test = test + "Artist ";
                                    break;
                                    case 2 :
                                        test = test + "Artist ";
                                    break;
                                    case 3 :
                                        test = test + "Artist ";
                                    break;
                                    case 4 :
                                        test = test + "Artist ";
                                    break;
                                    case 5 :
                                        test = test + "(Artist) ";
                                    break;
                                    case 6 :
                                        test = test + "[Artist] ";
                                    break;
                                    case 7 :
                                        test = test + "Artist ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Artist - ";
                                    break;
                                    case 1 :
                                        test = test + "Artist : ";
                                    break;
                                    case 2 :
                                        test = test + "Artist * ";
                                    break;
                                    case 3 :
                                        test = test + "Artist / ";
                                    break;
                                    case 4 :
                                        test = test + "Artist \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Artist) ";
                                    break;
                                    case 6 :
                                        test = test + "[Artist] ";
                                    break;
                                    case 7 :
                                        test = test + "Artist ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Artiste ";
                                    break;
                                    case 1 :
                                        test = test + "Artiste ";
                                    break;
                                    case 2 :
                                        test = test + "Artiste ";
                                    break;
                                    case 3 :
                                        test = test + "Artiste ";
                                    break;
                                    case 4 :
                                        test = test + "Artiste ";
                                    break;
                                    case 5 :
                                        test = test + "(Artiste) ";
                                    break;
                                    case 6 :
                                        test = test + "[Artiste] ";
                                    break;
                                    case 7 :
                                        test = test + "Artiste ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Artiste - ";
                                    break;
                                    case 1 :
                                        test = test + "Artiste : ";
                                    break;
                                    case 2 :
                                        test = test + "Artiste * ";
                                    break;
                                    case 3 :
                                        test = test + "Artiste / ";
                                    break;
                                    case 4 :
                                        test = test + "Artiste \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Artiste) ";
                                    break;
                                    case 6 :
                                        test = test + "[Artiste] ";
                                    break;
                                    case 7 :
                                        test = test + "Artiste ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                    break;
                    case 1 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Titel ";
                                    break;
                                    case 1 :
                                        test = test + "Titel ";
                                    break;
                                    case 2 :
                                        test = test + "Titel ";
                                    break;
                                    case 3 :
                                        test = test + "Titel ";
                                    break;
                                    case 4 :
                                        test = test + "Titel ";
                                    break;
                                    case 5 :
                                        test = test + "(Titel) ";
                                    break;
                                    case 6 :
                                        test = test + "[Titel] ";
                                    break;
                                    case 7 :
                                        test = test + "Titel ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Titel - ";
                                    break;
                                    case 1 :
                                        test = test + "Titel : ";
                                    break;
                                    case 2 :
                                        test = test + "Titel * ";
                                    break;
                                    case 3 :
                                        test = test + "Titel / ";
                                    break;
                                    case 4 :
                                        test = test + "Titel \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Titel) ";
                                    break;
                                    case 6 :
                                        test = test + "[Titel] ";
                                    break;
                                    case 7 :
                                        test = test + "Titel ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Title ";
                                    break;
                                    case 1 :
                                        test = test + "Title ";
                                    break;
                                    case 2 :
                                        test = test + "Title ";
                                    break;
                                    case 3 :
                                        test = test + "Title ";
                                    break;
                                    case 4 :
                                        test = test + "Title ";
                                    break;
                                    case 5 :
                                        test = test + "(Title) ";
                                    break;
                                    case 6 :
                                        test = test + "[Title] ";
                                    break;
                                    case 7 :
                                        test = test + "Title ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Title - ";
                                    break;
                                    case 1 :
                                        test = test + "Title : ";
                                    break;
                                    case 2 :
                                        test = test + "Title * ";
                                    break;
                                    case 3 :
                                        test = test + "Title / ";
                                    break;
                                    case 4 :
                                        test = test + "Title \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Title) ";
                                    break;
                                    case 6 :
                                        test = test + "[Title] ";
                                    break;
                                    case 7 :
                                        test = test + "Title ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Chanson ";
                                    break;
                                    case 1 :
                                        test = test + "Chanson ";
                                    break;
                                    case 2 :
                                        test = test + "Chanson ";
                                    break;
                                    case 3 :
                                        test = test + "Chanson ";
                                    break;
                                    case 4 :
                                        test = test + "Chanson ";
                                    break;
                                    case 5 :
                                        test = test + "(Chanson) ";
                                    break;
                                    case 6 :
                                        test = test + "[Chanson] ";
                                    break;
                                    case 7 :
                                        test = test + "Chanson ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Chanson - ";
                                    break;
                                    case 1 :
                                        test = test + "Chanson : ";
                                    break;
                                    case 2 :
                                        test = test + "Chanson * ";
                                    break;
                                    case 3 :
                                        test = test + "Chanson / ";
                                    break;
                                    case 4 :
                                        test = test + "Chanson \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Chanson) ";
                                    break;
                                    case 6 :
                                        test = test + "[Chanson] ";
                                    break;
                                    case 7 :
                                        test = test + "Chanson ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                    break;
                    case 2 :
                        if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                        {
                            switch (testdelemiter[i])
                            {
                                case 0 :
                                        test = test + "Album ";
                                break;
                                case 1 :
                                        test = test + "Album ";
                                break;
                                case 2 :
                                        test = test + "Album ";
                                break;
                                case 3 :
                                        test = test + "Album ";
                                break;
                                case 4 :
                                        test = test + "Album ";
                                break;
                                case 5 :
                                        test = test + "(Album) ";
                                break;
                                case 6 :
                                        test = test + "[Album] ";
                                break;
                                case 7 :
                                        test = test + "Album ";
                                break;
                                default :
                                break;
                            }
                        }
                        else
                        {
                            switch (testdelemiter[i])
                            {
                                case 0 :
                                        test = test + "Album - ";
                                break;
                                case 1 :
                                        test = test + "Album : ";
                                break;
                                case 2 :
                                        test = test + "Album * ";
                                break;
                                case 3 :
                                        test = test + "Album / ";
                                break;
                                case 4 :
                                        test = test + "Album \ ";
                                break;
                                case 5 :
                                        test = test + "(Album) ";
                                break;
                                case 6 :
                                        test = test + "[Album] ";
                                break;
                                case 7 :
                                        test = test + "Album ";
                                break;
                                default :
                                break;
                            }
                        }
                    break;
                    case 3 :
                        if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                        {
                            switch (testdelemiter[i])
                            {
                                case 0 :
                                        test = test + "Genre ";
                                break;
                                case 1 :
                                        test = test + "Genre ";
                                break;
                                case 2 :
                                        test = test + "Genre ";
                                break;
                                case 3 :
                                        test = test + "Genre ";
                                break;
                                case 4 :
                                        test = test + "Genre ";
                                break;
                                case 5 :
                                        test = test + "(Genre) ";
                                break;
                                case 6 :
                                        test = test + "[Genre] ";
                                break;
                                case 7 :
                                        test = test + "Genre ";
                                break;
                                default :
                                break;
                            }
                        }
                        else
                        {
                            switch (testdelemiter[i])
                            {
                                case 0 :
                                        test = test + "Genre - ";
                                break;
                                case 1 :
                                        test = test + "Genre : ";
                                break;
                                case 2 :
                                        test = test + "Genre * ";
                                break;
                                case 3 :
                                        test = test + "Genre / ";
                                break;
                                case 4 :
                                        test = test + "Genre \ ";
                                break;
                                case 5 :
                                        test = test + "(Genre) ";
                                break;
                                case 6 :
                                        test = test + "[Genre] ";
                                break;
                                case 7 :
                                        test = test + "Genre ";
                                break;
                                default :
                                break;
                            }
                        }
                    break;
                    case 4 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Jahr ";
                                    break;
                                    case 1 :
                                        test = test + "Jahr ";
                                    break;
                                    case 2 :
                                        test = test + "Jahr ";
                                    break;
                                    case 3 :
                                        test = test + "Jahr ";
                                    break;
                                    case 4 :
                                        test = test + "Jahr ";
                                    break;
                                    case 5 :
                                        test = test + "(Jahr) ";
                                    break;
                                    case 6 :
                                        test = test + "[Jahr] ";
                                    break;
                                    case 7 :
                                        test = test + "Jahr ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Jahr - ";
                                    break;
                                    case 1 :
                                        test = test + "Jahr : ";
                                    break;
                                    case 2 :
                                        test = test + "Jahr * ";
                                    break;
                                    case 3 :
                                        test = test + "Jahr / ";
                                    break;
                                    case 4 :
                                        test = test + "Jahr \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Jahr) ";
                                    break;
                                    case 6 :
                                        test = test + "[Jahr] ";
                                    break;
                                    case 7 :
                                        test = test + "Jahr ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Year ";
                                    break;
                                    case 1 :
                                        test = test + "Year ";
                                    break;
                                    case 2 :
                                        test = test + "Year ";
                                    break;
                                    case 3 :
                                        test = test + "Year ";
                                    break;
                                    case 4 :
                                        test = test + "Year ";
                                    break;
                                    case 5 :
                                        test = test + "(Year) ";
                                    break;
                                    case 6 :
                                        test = test + "[Year] ";
                                    break;
                                    case 7 :
                                        test = test + "Year ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Year - ";
                                    break;
                                    case 1 :
                                        test = test + "Year : ";
                                    break;
                                    case 2 :
                                        test = test + "Year * ";
                                    break;
                                    case 3 :
                                        test = test + "Year / ";
                                    break;
                                    case 4 :
                                        test = test + "Year \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Year) ";
                                    break;
                                    case 6 :
                                        test = test + "[Year] ";
                                    break;
                                    case 7 :
                                        test = test + "Year ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Anne ";
                                    break;
                                    case 1 :
                                        test = test + "Anne ";
                                    break;
                                    case 2 :
                                        test = test + "Anne ";
                                    break;
                                    case 3 :
                                        test = test + "Anne ";
                                    break;
                                    case 4 :
                                        test = test + "Anne ";
                                    break;
                                    case 5 :
                                        test = test + "(Anne) ";
                                    break;
                                    case 6 :
                                        test = test + "[Anne] ";
                                    break;
                                    case 7 :
                                        test = test + "Anne ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Anne - ";
                                    break;
                                    case 1 :
                                        test = test + "Anne : ";
                                    break;
                                    case 2 :
                                        test = test + "Anne * ";
                                    break;
                                    case 3 :
                                        test = test + "Anne / ";
                                    break;
                                    case 4 :
                                        test = test + "Anne \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Anne) ";
                                    break;
                                    case 6 :
                                        test = test + "[Anne] ";
                                    break;
                                    case 7 :
                                        test = test + "Anne ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                    break;
                    case 5 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Kommentar ";
                                    break;
                                    case 1 :
                                        test = test + "Kommentar ";
                                    break;
                                    case 2 :
                                        test = test + "Kommentar ";
                                    break;
                                    case 3 :
                                        test = test + "Kommentar ";
                                    break;
                                    case 4 :
                                        test = test + "Kommentar ";
                                    break;
                                    case 5 :
                                        test = test + "(Kommentar) ";
                                    break;
                                    case 6 :
                                        test = test + "[Kommentar] ";
                                    break;
                                    case 7 :
                                        test = test + "Kommentar ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Kommentar - ";
                                    break;
                                    case 1 :
                                        test = test + "Kommentar : ";
                                    break;
                                    case 2 :
                                        test = test + "Kommentar * ";
                                    break;
                                    case 3 :
                                        test = test + "Kommentar / ";
                                    break;
                                    case 4 :
                                        test = test + "Kommentar \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Kommentar) ";
                                    break;
                                    case 6 :
                                        test = test + "[Kommentar] ";
                                    break;
                                    case 7 :
                                        test = test + "Kommentar ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Comment ";
                                    break;
                                    case 1 :
                                        test = test + "Comment ";
                                    break;
                                    case 2 :
                                        test = test + "Comment ";
                                    break;
                                    case 3 :
                                        test = test + "Comment ";
                                    break;
                                    case 4 :
                                        test = test + "Comment ";
                                    break;
                                    case 5 :
                                        test = test + "(Comment) ";
                                    break;
                                    case 6 :
                                        test = test + "[Comment] ";
                                    break;
                                    case 7 :
                                        test = test + "Comment ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Comment - ";
                                    break;
                                    case 1 :
                                        test = test + "Comment : ";
                                    break;
                                    case 2 :
                                        test = test + "Comment * ";
                                    break;
                                    case 3 :
                                        test = test + "Comment / ";
                                    break;
                                    case 4 :
                                        test = test + "Comment \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Comment) ";
                                    break;
                                    case 6 :
                                        test = test + "[Comment] ";
                                    break;
                                    case 7 :
                                        test = test + "Comment ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (testchoice[i+1] == 6 || testchoice[i+1] == -1 || i == 5 || testdelemiter[i+1] == 5 || testdelemiter[i+1] == 6)
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Commentaire ";
                                    break;
                                    case 1 :
                                        test = test + "Commentaire ";
                                    break;
                                    case 2 :
                                        test = test + "Commentaire ";
                                    break;
                                    case 3 :
                                        test = test + "Commentaire ";
                                    break;
                                    case 4 :
                                        test = test + "Commentaire ";
                                    break;
                                    case 5 :
                                        test = test + "(Commentaire) ";
                                    break;
                                    case 6 :
                                        test = test + "[Commentaire] ";
                                    break;
                                    case 7 :
                                        test = test + "Commentaire ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                            else
                            {
                                switch (testdelemiter[i])
                                {
                                    case 0 :
                                        test = test + "Commentaire - ";
                                    break;
                                    case 1 :
                                        test = test + "Commentaire : ";
                                    break;
                                    case 2 :
                                        test = test + "Commentaire * ";
                                    break;
                                    case 3 :
                                        test = test + "Commentaire / ";
                                    break;
                                    case 4 :
                                        test = test + "Commentaire \ ";
                                    break;
                                    case 5 :
                                        test = test + "(Commentaire) ";
                                    break;
                                    case 6 :
                                        test = test + "[Commentaire] ";
                                    break;
                                    case 7 :
                                        test = test + "Commentaire ";
                                    break;
                                    default :
                                    break;
                                }
                            }
                        }
                    break;
                    default :
                    break;
                }
/*
        for (int i=0; i<6; i++)
        {
                switch (choice[i])
                {
                    case 0 :
                        if (OptionenDialog->Deutsch->Enabled==false || OptionenDialog->English->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "Artist";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                    test = test + "Artist ";
                            else
                                    test = test + "Artist - ";
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "Artiste";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                    test = test + "Artiste ";
                            else
                                    test = test + "Artiste - ";
                        }
                    break;
                    case 1 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "Titel";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                    test = test + "Titel ";
                            else
                                    test = test + "Titel - ";
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "Title";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                    test = test + "Title ";
                            else
                                    test = test + "Title - ";
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "Chanson";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                    test = test + "Chanson ";
                            else
                                    test = test + "Chanson - ";
                        }
                    break;
                    case 2 :
                        if (i==5)
                                test = test + "[ Album ]";
                        else
                                test = test + "[ Album ] ";
                    break;
                    case 3 :
                        if (i==5)
                                test = test + "Genre";
                        else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                test = test + "Genre ";
                        else
                                test = test + "Genre - ";
                    break;
                    case 4 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "( Jahr )";
                            else
                                    test = test + "( Jahr ) ";
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "( Year )";
                            else
                                    test = test + "( Year ) ";
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (i==5)
                                    test = test + "( Anne )";
                            else
                                    test = test + "( Anne ) ";
                        }
                    break;
                    case 5 :
                        if (OptionenDialog->Deutsch->Enabled==false)
                        {
                            if (i==5)
                                test = test + "Kommentar";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                test = test + "Kommentar ";
                            else
                                test = test + "Kommentar - ";
                        }
                        else if (OptionenDialog->English->Enabled==false)
                        {
                            if (i==5)
                                test = test + "Comment";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                test = test + "Comment ";
                            else
                                test = test + "Comment - ";
                        }
                        else if (OptionenDialog->Francais->Enabled==false)
                        {
                            if (i==5)
                                test = test + "Commentaire";
                            else if (choice[i+1] == 2 || choice[i+1] == 4 || choice[i+1] == 6 || choice[i+1] == -1)
                                test = test + "Commentaire ";
                            else
                                test = test + "Commentaire - ";
                        }
                    break;
                    default :
                    break;
                }
*/
                TestLabel->Caption = test;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormatierungsDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TFormatierungsDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                FormatierungsDialog->Left = FormatierungsDialog->Left + ( X - FMoveX);
                FormatierungsDialog->Top = FormatierungsDialog->Top + ( Y - FMoveY);
                FormatierungsDialog->Perform ( WM_PAINT,0,0 );
                HauptFormular->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------



