//---------------------------------------------------------------------------
#ifndef HauptprogrammH
#define HauptprogrammH
//---------------------------------------------------------------------------
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <fstream.h>
#include <io.h>
#include <iostream.h>
#include <process.h>
#include <sstream.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <Buttons.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Filectrl.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include "BrowseDlg.h"
#include "MP3Tag.hpp"
#include "TFlatAnimWndUnit.hpp"
#include "TFlatButtonUnit.hpp"
#include "TFlatEditUnit.hpp"
#include "TFlatSpinEditUnit.hpp"
#include "TrayComp.h"
#include <sys/types.h>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include <Registry.hpp>
#include <jpeg.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include "About.h"
#include "BrowseDlg.h"
#include "bgchoose.h"
#include "Export.h"
#include "Fontchoose.h"
#include "Formatierung.h"
#include "FortschrittsDialog.h"
#include "ID3Sort.h"
#include "Language.h"
#include "MP3DirChoose.h"
#include "New.h"
#include "Optionen.h"
#include "OverScanRahmen.h"
#include "BrowseDlg.h"
#include "MP3Tag.hpp"
#include "cxAbout.hpp"
#include "BMShapedButton.h"
#include "BMShapedForm.h"
#include "BrowseDlg.h"
#include "MP3Tag.hpp"
#include "TrayComp.h"
#include "LxCheckBox.h"
#include "MP3Info.h"
#include "ScrollLabel.hpp"
#include "TrayComp.h"
#include "BrowseDlg.h"

#define B_LEN 16384
#define PERM   0644

enum TDrawingTool {dtRectangle};

//---------------------------------------------------------------------------
class THauptFormular : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TLabel *UeberschriftLabel;
        TMP3Tag *MP3Tag;
    TLabel *AnzahlTitelSeiteLabel;
    TLabel *VorschauSeiteLabel;
    TFlatButton *MakeButton;
    TFlatButton *VorschauButton;
    TFlatButton *ID3FormatButton;
    TFlatButton *AboutButton;
    TFlatButton *HilfeButton;
    TFlatButton *MP3DirButton;
    TFlatButton *BackgroundButton;
    TFlatButton *FontsButton;
    TFlatButton *OptionenButton;
        TImage *Image;
    TLabel *YamakawaToolLabel;
    TFlatButton *ExitButton;
        TFlatSpinEditInteger *SeiteNr;
        TFlatSpinEditInteger *TitelSeite;
        TFlatEdit *ProjektName;
    TLabel *Version;
        TPopupMenu *PopupMenu1;
        TMenuItem *Restore1;
        TMenuItem *N1;
        TMenuItem *Exit1;
        TBevel *Bevel1;
    TSpeedButton *SystemMenuButton;
        TPopupMenu *PopupMenu2;
        TMenuItem *MenuItem3;
        TMenuItem *N2;
        TMenuItem *About1;
        TImageList *ImageList1;
    TImage *Hintergrund;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TMenuItem *Hilfe1;
    TMenuItem *N3;
    TMenuItem *About2;
    TLabel *Label1;
    TFlatButton *Sortierung;
    TFlatAnimWnd *FlatAnimWnd1;
        void __fastcall OeffnenClick(TObject *Sender);
        void __fastcall SpeichernUnterClick(TObject *Sender);
        void __fastcall AboutAufrufClick(TObject *Sender);
        void __fastcall ExitClick(TObject *Sender);
        void __fastcall ProjektName0Change(TObject *Sender);
        void __fastcall SpeichernClick(TObject *Sender);
        void __fastcall OverscanRahmenClick(TObject *Sender);
        void __fastcall MakeButtonClick(TObject *Sender);
        void __fastcall FormatierungClick(TObject *Sender);
        void __fastcall OptionenClick(TObject *Sender);
        void __fastcall VorschauButtonClick(TObject *Sender);
        void __fastcall Ausgabereihenfolge1Click(TObject *Sender);
//        void __fastcall FontDialog2Apply(TObject *Sender, HWND Wnd);
//        void __fastcall FontDialogApply(TObject *Sender, HWND Wnd);
        void __fastcall Whatsnew1Click(TObject *Sender);
        void __fastcall MP3DirButtonClick(TObject *Sender);
        void __fastcall ID3FormatButtonClick(TObject *Sender);
        void __fastcall BackgroundButtonClick(TObject *Sender);
        void __fastcall FontsButtonClick(TObject *Sender);
        void __fastcall MinimizeClick(TObject *Sender);
        void __fastcall RestoreClick(TObject *Sender);
        void __fastcall TrayComp1Restore(TObject *Sender);
        void __fastcall TrayComp1Minimize(TObject *Sender);
        void __fastcall SystemMenuButtonClick(TObject *Sender);
    void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall WriteRegistry(TObject *Sender);
    void __fastcall ReadRegistry(TObject *Sender);
    void __fastcall Timer(TObject *Sender);
    private:	// Anwenderdeklarationen
    public:		// Anwenderdeklarationen
        int   FMoveX;
        int   FMoveY;
    	AnsiString CurrentFile, Titel, mp3path, copypath;
    	AnsiString YamVersion;
	    AnsiString **mp3array;
        TDrawingTool DrawingTool;
        TPoint Origin, MovePt;
        char* mp3dir;
        char* mklogo;
        char* c2bin;
        char startdir[MAXPATH];
        char buffer[MAXPATH];
        char bgpicture[MAXPATH];
        char bgpicture2[MAXPATH];
        char bgpicture3[MAXPATH];
        char bgpicture4[MAXPATH];
        char buffer2[MAXPATH];
        bool Drawing;
        bool bgfarbe;
        bool shuffledlist;
        int count, anzahl;
        int pbarcount, zeit;
        double inc, remain;
        time_t first, second;

        __fastcall THauptFormular(TComponent* Owner);
        void __fastcall DrawShape(TPoint TopLeft, TPoint BottomRight, TPenMode AMode);
        AnsiString** ID3TagAuslesen();
        void Hintergrundwahl();
        void TextFileWriter(AnsiString[]);
        void Umbenennen(int, AnsiString);
        void PrintToScreen(int, int, int, int, int);
        void TranslateToFrench();
        void TranslateToEnglish();
        void TranslateToGerman();
        void copy(char* Quelle, char* Ziel);
};
//----------------------------------------------------------------------------
extern PACKAGE THauptFormular *HauptFormular;
//---------------------------------------------------------------------------
#endif
   