//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ID3Sort.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "WrapGrid"
#pragma link "TFlatButtonUnit"
#pragma link "AdvGrid"
#pragma link "TFlatEditUnit"
#pragma link "TFlatSpinEditUnit"
#pragma link "TFlatHintUnit"
#pragma link "ScrollLabel"
#pragma resource "*.dfm"
TSortDialog *SortDialog;
//---------------------------------------------------------------------------
__fastcall TSortDialog::TSortDialog(TComponent* Owner)
    : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateRoundRectRgn(0, 0, 810, 500, 20, 20);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture4);

      Concatenize = new char[256];
      Concatenize2 = new char[256];

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TSortDialog::FormActivate(TObject *Sender)
{
    WrapGrid1->RowCount=HauptFormular->anzahl+1;

    WrapGrid1->Cells[0][0] = "Indexnr.";
    WrapGrid1->Cells[1][0] = "Artist";
    WrapGrid1->Cells[2][0] = "Titel";
    WrapGrid1->Cells[3][0] = "Album";
    WrapGrid1->Cells[4][0] = "Genre";
    WrapGrid1->Cells[5][0] = "Jahr";
    WrapGrid1->Cells[6][0] = "Kommentar";

    for (int i = 0; i < HauptFormular->anzahl; i++)
    {
        WrapGrid1->FixedRows=1;
        WrapGrid1->Cells[0][i+1] = i+1;
        WrapGrid1->Cells[1][i+1] = HauptFormular->mp3array[i][2].c_str();
        WrapGrid1->Cells[2][i+1] = HauptFormular->mp3array[i][3].c_str();
        WrapGrid1->Cells[3][i+1] = HauptFormular->mp3array[i][4].c_str();
        WrapGrid1->Cells[4][i+1] = HauptFormular->mp3array[i][5].c_str();
        WrapGrid1->Cells[5][i+1] = HauptFormular->mp3array[i][6].c_str();
        WrapGrid1->Cells[6][i+1] = HauptFormular->mp3array[i][7].c_str();
//        WrapGrid1->Cells[7][i+1] = HauptFormular->mp3array[i][0].c_str();
//        WrapGrid1->Cells[8][i+1] = HauptFormular->mp3array[i][1].c_str();
//        WrapGrid1->Cells[9][i+1] = HauptFormular->mp3array[i][8].c_str();
    }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                SortDialog->Left = SortDialog->Left + ( X - FMoveX);
                SortDialog->Top = SortDialog->Top + ( Y - FMoveY);
                SortDialog->Perform ( WM_PAINT,0,0 );
                HauptFormular->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FlatButton13Click(TObject *Sender)
{
        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct;
        TList *MyList = new TList;

        for (int k = 0; k < HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        AfterSort(Sender);

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        HauptFormular->VorschauButtonClick(Sender);
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FlatButtonClick(TObject *Sender)
{
        ExportDialog->Visible = true;
        ExportDialog->BringToFront();
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::ArtistSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Artist == BStruct->Artist && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::TitleSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->Title == BStruct->Title && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::AlbumSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Album < BStruct->Album && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->Album == BStruct->Album && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Artist == BStruct->Artist && AStruct->Album == BStruct->Album && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::GenreSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Genre < BStruct->Genre && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->Genre == BStruct->Genre && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Artist == BStruct->Artist && AStruct->Genre == BStruct->Genre && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::AfterSort(TObject *Sender)
{
    WrapGrid1->Clear();
    WrapGrid1->RowCount=HauptFormular->anzahl+1;

    for (int i = 0; i < HauptFormular->anzahl; i++)
    {
        WrapGrid1->FixedRows=1;
        WrapGrid1->Cells[0][i+1] = i+1;
        WrapGrid1->Cells[1][i+1] = HauptFormular->mp3array[i][2].c_str();
        WrapGrid1->Cells[2][i+1] = HauptFormular->mp3array[i][3].c_str();
        WrapGrid1->Cells[3][i+1] = HauptFormular->mp3array[i][4].c_str();
        WrapGrid1->Cells[4][i+1] = HauptFormular->mp3array[i][5].c_str();
        WrapGrid1->Cells[5][i+1] = HauptFormular->mp3array[i][6].c_str();
        WrapGrid1->Cells[6][i+1] = HauptFormular->mp3array[i][7].c_str();
//        WrapGrid1->Cells[7][i+1] = HauptFormular->mp3array[i][0].c_str();
//        WrapGrid1->Cells[8][i+1] = HauptFormular->mp3array[i][1].c_str();
//        WrapGrid1->Cells[9][i+1] = HauptFormular->mp3array[i][8].c_str();
    }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::SaveID3TagsClick(TObject *Sender)
{
    const char *ID3_Genres[] = {"Blues","Classic Rock","Country","Dance","Disco","Funk","Grunge","Hip-Hop","Jazz",
                             "Metal","New Age","Oldies","Other","Pop","R&B","Rap","Reggae","Rock","Techno","Industrial",
                             "Alternative","Ska","Death Metal","Pranks","Soundtrack","Euro-Techno","Ambient","Trip-Hop",
                             "Vocal","Jazz+Funk","Fusion","Trance","Classical","Instrumental","Acid","House","Game",
                             "Sound Clip","Gospel","Noise","AlternRock","Bass","Soul","Punk","Space","Meditative",
                             "Instrumental Pop","Instrumental Rock","Ethnic","Gothic","Darkwave","Techno-Industrial",
                             "Electronic","Pop-Folk","Eurodance","Dream","Southern Rock","Comedy","Cult","Gangsta",
                             "Top 40","Christian Rap","Pop/Funk","Jungle","Native American","Cabaret","New Wave",
                             "Psychadelic","Rave","Showtunes","Trailer","Lo-Fi","Tribal","Acid Punk","Acid Jazz","Polka",
                             "Retro","Musical","Rock & Roll","Hard Rock", NULL};

    int button;

    button = Application->MessageBox("Wollen Sie wirklich in !!!ALLE!!! MP3-Dateien die von Ihnen, im Dialog genderten Tags, speichern ???", "B-TO Y  Sicherheitsabfrage", MB_YESNO + MB_DEFBUTTON1 + MB_ICONWARNING);
    if (button == IDNO)
    {
    }
    else if (button == IDYES)
    {
        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AnsiString tempfile;
            int ptr;

            ptr = strcmpi(".", HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str());

            if(ptr == 0)
            {
                tempfile = DirectoryDialog->Quellverzeichnis->Text + "\\";
                tempfile = tempfile + HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1];
            }
            else
            {
                tempfile = DirectoryDialog->Quellverzeichnis->Text + "\\";
                tempfile = tempfile + HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0];
                tempfile = tempfile + "\\";
                tempfile = tempfile + HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1];
            }


            HauptFormular->MP3Tag->Filename=tempfile;
            HauptFormular->MP3Tag->Artist=WrapGrid1->Cells[1][k+1];
            HauptFormular->MP3Tag->Title=WrapGrid1->Cells[2][k+1];
            HauptFormular->MP3Tag->Album=WrapGrid1->Cells[3][k+1];

            int number=0;

            while(WrapGrid1->Cells[4][k+1]!=ID3_Genres[number] && number<=255)
            {
                number++;
            }

            HauptFormular->MP3Tag->GenreID=number;

            HauptFormular->MP3Tag->Year=WrapGrid1->Cells[5][k+1];
            HauptFormular->MP3Tag->Comment=WrapGrid1->Cells[6][k+1];
            HauptFormular->MP3Tag->Save();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::CancelClick(TObject *Sender)
{
        HauptFormular->VorschauButtonClick(Sender);
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::YearSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Year < BStruct->Year && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->Year == BStruct->Year && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Artist == BStruct->Artist && AStruct->Year == BStruct->Year && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FileNameSort(TObject *Sender)
{
        HauptFormular->shuffledlist=false;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct, BStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Path < BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->FileName < BStruct->FileName && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Artist < BStruct->Artist && AStruct->FileName == BStruct->FileName && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

    	for(int m= 0; m<HauptFormular->anzahl; m++)
	    {
    		for(int n=HauptFormular->anzahl-1; n>0; n--)
		    {
                AStruct = (PAList) MyList->Items[n];
                BStruct = (PAList) MyList->Items[n-1];

	    		if (AStruct->Title < BStruct->Title && AStruct->Artist == BStruct->Artist && AStruct->FileName == BStruct->FileName && AStruct->Path == BStruct->Path)
    			{
                    MyList->Exchange(n, n-1);
	    		}
    		}
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::WrapGrid1GetEditorType(TObject *Sender,
      int aCol, int aRow, TEditorType &aEditor)
{
    switch (aCol)
    {
        case 4 :
            aEditor=edComboList;
            WrapGrid1->Combobox->Items->Add("Blues");
            WrapGrid1->Combobox->Items->Add("Classic Rock");
            WrapGrid1->Combobox->Items->Add("Country");
            WrapGrid1->Combobox->Items->Add("Dance");
            WrapGrid1->Combobox->Items->Add("Disco");
            WrapGrid1->Combobox->Items->Add("Funk");
            WrapGrid1->Combobox->Items->Add("Grunge");
            WrapGrid1->Combobox->Items->Add("Hip-Hop");
            WrapGrid1->Combobox->Items->Add("Jazz");
            WrapGrid1->Combobox->Items->Add("Blues");
            WrapGrid1->Combobox->Items->Add("Blues");
            WrapGrid1->Combobox->Items->Add("Metal");
            WrapGrid1->Combobox->Items->Add("New Age");
            WrapGrid1->Combobox->Items->Add("Oldies");
            WrapGrid1->Combobox->Items->Add("Other");
            WrapGrid1->Combobox->Items->Add("Pop");
            WrapGrid1->Combobox->Items->Add("R&B");
            WrapGrid1->Combobox->Items->Add("Rap");
            WrapGrid1->Combobox->Items->Add("Reggae");
            WrapGrid1->Combobox->Items->Add("Rock");
            WrapGrid1->Combobox->Items->Add("Techno");
            WrapGrid1->Combobox->Items->Add("Industrial");
            WrapGrid1->Combobox->Items->Add("Alternative");
            WrapGrid1->Combobox->Items->Add("Ska");
            WrapGrid1->Combobox->Items->Add("Death Metal");
            WrapGrid1->Combobox->Items->Add("Pranks");
            WrapGrid1->Combobox->Items->Add("Soundtrack");
            WrapGrid1->Combobox->Items->Add("Euro-Techno");
            WrapGrid1->Combobox->Items->Add("Ambient");
            WrapGrid1->Combobox->Items->Add("Trip-Hop");
            WrapGrid1->Combobox->Items->Add("Vocal");
            WrapGrid1->Combobox->Items->Add("Jazz+Funk");
            WrapGrid1->Combobox->Items->Add("Fusion");
            WrapGrid1->Combobox->Items->Add("Trance");
            WrapGrid1->Combobox->Items->Add("Classical");
            WrapGrid1->Combobox->Items->Add("Instrumental");
            WrapGrid1->Combobox->Items->Add("Acid");
            WrapGrid1->Combobox->Items->Add("House");
            WrapGrid1->Combobox->Items->Add("Game");
            WrapGrid1->Combobox->Items->Add("Sound Clip");
            WrapGrid1->Combobox->Items->Add("Gospel");
            WrapGrid1->Combobox->Items->Add("Noise");
            WrapGrid1->Combobox->Items->Add("AlternRock");
            WrapGrid1->Combobox->Items->Add("Bass");
            WrapGrid1->Combobox->Items->Add("Soul");
            WrapGrid1->Combobox->Items->Add("Punk");
            WrapGrid1->Combobox->Items->Add("Space");
            WrapGrid1->Combobox->Items->Add("Meditative");
            WrapGrid1->Combobox->Items->Add("Instrumental Pop");
            WrapGrid1->Combobox->Items->Add("Instrumental Rock");
            WrapGrid1->Combobox->Items->Add("Ethnic");
            WrapGrid1->Combobox->Items->Add("Gothic");
            WrapGrid1->Combobox->Items->Add("Darkwave");
            WrapGrid1->Combobox->Items->Add("Techno-Industrial");
            WrapGrid1->Combobox->Items->Add("Electronic");
            WrapGrid1->Combobox->Items->Add("Pop-Folk");
            WrapGrid1->Combobox->Items->Add("Eurodance");
            WrapGrid1->Combobox->Items->Add("Dream");
            WrapGrid1->Combobox->Items->Add("Southern Rock");
            WrapGrid1->Combobox->Items->Add("Comedy");
            WrapGrid1->Combobox->Items->Add("Cult");
            WrapGrid1->Combobox->Items->Add("Gangsta");
            WrapGrid1->Combobox->Items->Add("Top 40");
            WrapGrid1->Combobox->Items->Add("Christian Rap");
            WrapGrid1->Combobox->Items->Add("Pop/Funk");
            WrapGrid1->Combobox->Items->Add("Jungle");
            WrapGrid1->Combobox->Items->Add("Native American");
            WrapGrid1->Combobox->Items->Add("Cabaret");
            WrapGrid1->Combobox->Items->Add("New Wave");
            WrapGrid1->Combobox->Items->Add("Psychadelic");
            WrapGrid1->Combobox->Items->Add("Rave");
            WrapGrid1->Combobox->Items->Add("Showtunes");
            WrapGrid1->Combobox->Items->Add("Trailer");
            WrapGrid1->Combobox->Items->Add("Lo-Fi");
            WrapGrid1->Combobox->Items->Add("Tribal");
            WrapGrid1->Combobox->Items->Add("Acid Punk");
            WrapGrid1->Combobox->Items->Add("Acid Jazz");
            WrapGrid1->Combobox->Items->Add("Polka");
            WrapGrid1->Combobox->Items->Add("Retro");
            WrapGrid1->Combobox->Items->Add("Musical");
            WrapGrid1->Combobox->Items->Add("Rock & Roll");
            WrapGrid1->Combobox->Items->Add("Hard Rock");
            WrapGrid1->Combobox->Items->Add("Folk");
            WrapGrid1->Combobox->Items->Add("Folk/Rock");
            WrapGrid1->Combobox->Items->Add("National Folk");
            WrapGrid1->Combobox->Items->Add("Swing");
            WrapGrid1->Combobox->Items->Add("Fast Fusion");
            WrapGrid1->Combobox->Items->Add("Bebob");
            WrapGrid1->Combobox->Items->Add("Latin");
            WrapGrid1->Combobox->Items->Add("Revival");
            WrapGrid1->Combobox->Items->Add("Celtic");
            WrapGrid1->Combobox->Items->Add("Bluegrass");
            WrapGrid1->Combobox->Items->Add("Avantgarde");
            WrapGrid1->Combobox->Items->Add("Gothic Rock");
            WrapGrid1->Combobox->Items->Add("Progressive Rock");
            WrapGrid1->Combobox->Items->Add("Psychedelic Rock");
            WrapGrid1->Combobox->Items->Add("Symphonic Rock");
            WrapGrid1->Combobox->Items->Add("Slow Rock");
            WrapGrid1->Combobox->Items->Add("Big Band");
            WrapGrid1->Combobox->Items->Add("Chorus");
            WrapGrid1->Combobox->Items->Add("Easy Listening");
            WrapGrid1->Combobox->Items->Add("Acoustic");
            WrapGrid1->Combobox->Items->Add("Humour");
            WrapGrid1->Combobox->Items->Add("Speech");
            WrapGrid1->Combobox->Items->Add("Chanson");
            WrapGrid1->Combobox->Items->Add("Opera");
            WrapGrid1->Combobox->Items->Add("Chamber Music");
            WrapGrid1->Combobox->Items->Add("Sonata");
            WrapGrid1->Combobox->Items->Add("Symphony");
            WrapGrid1->Combobox->Items->Add("Booty Bass");
            WrapGrid1->Combobox->Items->Add("Primus");
            WrapGrid1->Combobox->Items->Add("Porn Groove");
            WrapGrid1->Combobox->Items->Add("Satire");
            WrapGrid1->Combobox->Items->Add("Slow Jam");
            WrapGrid1->Combobox->Items->Add("Club");
            WrapGrid1->Combobox->Items->Add("Tango");
            WrapGrid1->Combobox->Items->Add("Samba");
            WrapGrid1->Combobox->Items->Add("Folklore");
            WrapGrid1->Combobox->Items->Add("Ballad");
            WrapGrid1->Combobox->Items->Add("Power Ballad");
            WrapGrid1->Combobox->Items->Add("Rhythmic Soul");
            WrapGrid1->Combobox->Items->Add("Freestyle");
            WrapGrid1->Combobox->Items->Add("Duet");
            WrapGrid1->Combobox->Items->Add("Punk Rock");
            WrapGrid1->Combobox->Items->Add("Drum Solo");
            WrapGrid1->Combobox->Items->Add("Acapella");
            WrapGrid1->Combobox->Items->Add("Euro-House");
            WrapGrid1->Combobox->Items->Add("Dance Hall");
            WrapGrid1->Combobox->Items->Add("Goa");
            WrapGrid1->Combobox->Items->Add("Drum & Bass");
            WrapGrid1->Combobox->Items->Add("Club-House");
            WrapGrid1->Combobox->Items->Add("Hardcore");
            WrapGrid1->Combobox->Items->Add("Terror");
            WrapGrid1->Combobox->Items->Add("Indie");
            WrapGrid1->Combobox->Items->Add("BritPop");
            WrapGrid1->Combobox->Items->Add("Negerpunk");
            WrapGrid1->Combobox->Items->Add("Polsk Punk");
            WrapGrid1->Combobox->Items->Add("Beat");
            WrapGrid1->Combobox->Items->Add("Christian Gangsta Rap");
            WrapGrid1->Combobox->Items->Add("Heavy Metal");
            WrapGrid1->Combobox->Items->Add("Black Metal");
            WrapGrid1->Combobox->Items->Add("Crossover");
            WrapGrid1->Combobox->Items->Add("Contemporary Christian");
            WrapGrid1->Combobox->Items->Add("Christian Rock");
            WrapGrid1->Combobox->Items->Add("Merengue");
            WrapGrid1->Combobox->Items->Add("Salsa");
            WrapGrid1->Combobox->Items->Add("Trash Metal");
//            WrapGrid1->Combobox->Items->LoadFromFile("genres.dat");
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::WrapGrid1DblClickCell(TObject *Sender,
      int Arow, int Acol)
{
    strcpy(Concatenize, "");
    strcpy(Concatenize2, "");

//        char* Result= new char[256];
//        FindExecutable("Ace of Base - Cruel Summer.mp3", "F:\\MP 3\\98\\", Result);
    strcpy(Concatenize, HauptFormular->mp3array[(WrapGrid1->Cells[0][Arow])-1][1].c_str());

//    ShellExecute(NULL, "open", "Ace of Base - Cruel Summer.mp3", NULL, "F:\\MP 3\\98\\", SW_SHOWNORMAL);
    if(HauptFormular->mp3array[(WrapGrid1->Cells[0][Acol])-1][0].c_str()==".")
    {
        strcat(Concatenize2, DirectoryDialog->Quellverzeichnis->Text.c_str());
    }
    else
    {
        strcat(Concatenize2, DirectoryDialog->Quellverzeichnis->Text.c_str());
        strcat(Concatenize2, "\\");
        strcat(Concatenize2, HauptFormular->mp3array[(StrToInt(WrapGrid1->Cells[0][Arow]))-1][0].c_str());
    }
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::CopyClick(TObject *Sender)

{
  TComponent *pComponent = PopupMenu->PopupComponent;
  if (pComponent)
  {
    if (pComponent->ClassNameIs("TEdit"))
      ((TEdit *)pComponent)->CopyToClipboard();
    else if (pComponent->ClassNameIs("TMemo"))
      ((TMemo *)pComponent)->CopyToClipboard();
    else if (pComponent->ClassNameIs("TAdvStringGrid"))
      ((TAdvStringGrid *)pComponent)-> CopySelectionToClipboard();
    else
    {
        MessageBeep(0);
    }
  }
  else
    MessageBeep(0);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::CutClick(TObject *Sender)

{
  TComponent *pComponent = PopupMenu->PopupComponent;
  if (pComponent)
  {
    if (pComponent->ClassNameIs("TEdit"))
      ((TEdit *)pComponent)->CutToClipboard();
    else if (pComponent->ClassNameIs("TMemo"))
      ((TMemo *)pComponent)->CutToClipboard();
    else if (pComponent->ClassNameIs("TAdvStringGrid"))
      ((TAdvStringGrid *)pComponent)->CutToClipboard();
    else
    {
        MessageBeep(0);
    }
  }
  else
    MessageBeep(0);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::PasteClick(TObject *Sender)

{
  TComponent *pComponent = PopupMenu->PopupComponent;
  if (pComponent)
  {
    if (pComponent->ClassNameIs("TEdit"))
      ((TEdit *)pComponent)->PasteFromClipboard();
    else if (pComponent->ClassNameIs("TMemo"))
      ((TMemo *)pComponent)->PasteFromClipboard();
    else if (pComponent->ClassNameIs("TAdvStringGrid"))
      ((TAdvStringGrid *)pComponent)->PasteSelectionFromClipboard();
    else
    {
        MessageBeep(0);
    }
  }
  else
    MessageBeep(0);
}
//---------------------------------------------------------------------------

void __fastcall TSortDialog::FormCreate(TObject *Sender)
{
  PopupMenu->AutoPopup = true;
  WrapGrid1->PopupMenu = PopupMenu;
}

void __fastcall TSortDialog::InMP3Playabspielen1Click(TObject *Sender)
{
        ShellExecute(NULL, "open", Concatenize, NULL, Concatenize2, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------


void __fastcall TSortDialog::Shuffle(TObject *Sender)
{
        HauptFormular->shuffledlist=true;

        typedef struct AList
        {
          AnsiString Artist;
          AnsiString Title;
          AnsiString Album;
          AnsiString Year;
          AnsiString Genre;
          AnsiString Comment;
          AnsiString DirNum;
          AnsiString Path;
          AnsiString FileName;
        } TAList;
        typedef TAList* PAList;

        PAList AStruct;
        TList *MyList = new TList;

        for (int k=0; k<HauptFormular->anzahl; k++)
        {
            AStruct = new TAList;
            AStruct->Artist=WrapGrid1->Cells[1][k+1];
            AStruct->Title=WrapGrid1->Cells[2][k+1];
            AStruct->Album=WrapGrid1->Cells[3][k+1];
            AStruct->Genre=WrapGrid1->Cells[4][k+1];
            AStruct->Year=WrapGrid1->Cells[5][k+1];
            AStruct->Comment=WrapGrid1->Cells[6][k+1];
            AStruct->DirNum=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][8].c_str();
            AStruct->Path=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][0].c_str();
            AStruct->FileName=HauptFormular->mp3array[(WrapGrid1->Cells[0][k+1])-1][1].c_str();
//            AStruct->DirNum=WrapGrid1->Cells[9][k+1];
//            AStruct->Path=WrapGrid1->Cells[7][k+1];
//            AStruct->FileName=WrapGrid1->Cells[8][k+1];
            MyList->Add(AStruct);
        }

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
                Randomize();
                int x = random(HauptFormular->anzahl);
                int y = random(HauptFormular->anzahl);

                MyList->Exchange(x, y);
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
                Randomize();
                int x = random(HauptFormular->anzahl);
                int y = random(HauptFormular->anzahl);

                MyList->Exchange(x, y);
    	}

    	for(int m=0; m<HauptFormular->anzahl; m++)
	    {
                Randomize();
                int x = random(HauptFormular->anzahl);
                int y = random(HauptFormular->anzahl);

                MyList->Exchange(x, y);
    	}

        for (int i = 0; i < HauptFormular->anzahl; i++)
        {
            AStruct = (PAList) MyList->Items[i];

            HauptFormular->mp3array[i][0]=AStruct->Path;
            HauptFormular->mp3array[i][1]=AStruct->FileName;
            HauptFormular->mp3array[i][2]=AStruct->Artist;
            HauptFormular->mp3array[i][3]=AStruct->Title;
            HauptFormular->mp3array[i][4]=AStruct->Album;
            HauptFormular->mp3array[i][5]=AStruct->Genre;
            HauptFormular->mp3array[i][6]=AStruct->Year;
            HauptFormular->mp3array[i][7]=AStruct->Comment;
            HauptFormular->mp3array[i][8]=AStruct->DirNum;
        }

        for (int i = 0; i < MyList->Count; i++)
        {
            AStruct = (PAList) MyList->Items[i];
            delete AStruct;
        }

        delete MyList;

        AfterSort(Sender);
}
//---------------------------------------------------------------------------

