//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Optionen.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BMShapedButton"
#pragma link "BMShapedForm"
#pragma link "TFlatButtonUnit"
#pragma link "TFlatCheckBoxUnit"
#pragma link "TFlatGroupBoxUnit"
#pragma link "TFlatPanelUnit"
#pragma resource "*.dfm"
TOptionenDialog *OptionenDialog;
//---------------------------------------------------------------------------
__fastcall TOptionenDialog::TOptionenDialog(TComponent* Owner)
        : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 700, 250);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture3);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TOptionenDialog::FlatButton13Click(TObject *Sender)
{
        HauptFormular->shuffledlist=false;
        HauptFormular->ID3TagAuslesen();
        HauptFormular->WriteRegistry(Sender);
        HauptFormular->VorschauButtonClick(Sender);
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                OptionenDialog->Left = OptionenDialog->Left + ( X - FMoveX);
                OptionenDialog->Top = OptionenDialog->Top + ( Y - FMoveY);
                OptionenDialog->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------




void __fastcall TOptionenDialog::FourDigitsClick(TObject *Sender)
{
    FontChooseDialog->DigitColor->Visible=FourDigits->Checked;
    FontChooseDialog->DigitColor2->Visible=FourDigits->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::DeutschClick(TObject *Sender)
{
  TRegistry *Reg = new TRegistry;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", true))
    {
        Reg->WriteInteger("Format1", FormatierungsDialog->ComboBox1->ItemIndex);
        Reg->WriteInteger("Format2", FormatierungsDialog->ComboBox2->ItemIndex);
        Reg->WriteInteger("Format3", FormatierungsDialog->ComboBox3->ItemIndex);
        Reg->WriteInteger("Format4", FormatierungsDialog->ComboBox4->ItemIndex);
        Reg->WriteInteger("Format5", FormatierungsDialog->ComboBox5->ItemIndex);
        Reg->WriteInteger("Format6", FormatierungsDialog->ComboBox6->ItemIndex);
        Reg->WriteInteger("Format7", FormatierungsDialog->ComboBox7->ItemIndex);
        Reg->WriteInteger("Format8", FormatierungsDialog->ComboBox8->ItemIndex);
        Reg->WriteInteger("Format9", FormatierungsDialog->ComboBox9->ItemIndex);
    }
  }
  __finally
  {
    Reg->CloseKey();
  }

    HauptFormular->TranslateToGerman();
    Francais->Enabled=true;
    English->Enabled=true;
    Deutsch->Enabled=false;
    Deutsch->Checked=false;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", false))
    {
        FormatierungsDialog->ComboBox1->ItemIndex=Reg->ReadInteger("Format1");
        FormatierungsDialog->ComboBox2->ItemIndex=Reg->ReadInteger("Format2");
        FormatierungsDialog->ComboBox3->ItemIndex=Reg->ReadInteger("Format3");
        FormatierungsDialog->ComboBox4->ItemIndex=Reg->ReadInteger("Format4");
        FormatierungsDialog->ComboBox5->ItemIndex=Reg->ReadInteger("Format5");
        FormatierungsDialog->ComboBox6->ItemIndex=Reg->ReadInteger("Format6");
        FormatierungsDialog->ComboBox7->ItemIndex=Reg->ReadInteger("Format7");
        FormatierungsDialog->ComboBox8->ItemIndex=Reg->ReadInteger("Format8");
        FormatierungsDialog->ComboBox9->ItemIndex=Reg->ReadInteger("Format9");
    }
    else
    {
    }
  }
  __finally
  {
    Reg->CloseKey();
    delete Reg;
  }
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::EnglishClick(TObject *Sender)
{
  TRegistry *Reg = new TRegistry;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", true))
    {
        Reg->WriteInteger("Format1", FormatierungsDialog->ComboBox1->ItemIndex);
        Reg->WriteInteger("Format2", FormatierungsDialog->ComboBox2->ItemIndex);
        Reg->WriteInteger("Format3", FormatierungsDialog->ComboBox3->ItemIndex);
        Reg->WriteInteger("Format4", FormatierungsDialog->ComboBox4->ItemIndex);
        Reg->WriteInteger("Format5", FormatierungsDialog->ComboBox5->ItemIndex);
        Reg->WriteInteger("Format6", FormatierungsDialog->ComboBox6->ItemIndex);
        Reg->WriteInteger("Format7", FormatierungsDialog->ComboBox7->ItemIndex);
        Reg->WriteInteger("Format8", FormatierungsDialog->ComboBox8->ItemIndex);
        Reg->WriteInteger("Format9", FormatierungsDialog->ComboBox9->ItemIndex);
    }
  }
  __finally
  {
    Reg->CloseKey();
  }

    HauptFormular->TranslateToEnglish();
    Francais->Enabled=true;
    Deutsch->Enabled=true;
    English->Enabled=false;
    English->Checked=false;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", false))
    {
        FormatierungsDialog->ComboBox1->ItemIndex=Reg->ReadInteger("Format1");
        FormatierungsDialog->ComboBox2->ItemIndex=Reg->ReadInteger("Format2");
        FormatierungsDialog->ComboBox3->ItemIndex=Reg->ReadInteger("Format3");
        FormatierungsDialog->ComboBox4->ItemIndex=Reg->ReadInteger("Format4");
        FormatierungsDialog->ComboBox5->ItemIndex=Reg->ReadInteger("Format5");
        FormatierungsDialog->ComboBox6->ItemIndex=Reg->ReadInteger("Format6");
        FormatierungsDialog->ComboBox7->ItemIndex=Reg->ReadInteger("Format7");
        FormatierungsDialog->ComboBox8->ItemIndex=Reg->ReadInteger("Format8");
        FormatierungsDialog->ComboBox9->ItemIndex=Reg->ReadInteger("Format9");
    }
    else
    {
    }
  }
  __finally
  {
    delete Reg;
  }
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::FrancaisClick(TObject *Sender)
{
  TRegistry *Reg = new TRegistry;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", true))
    {
        Reg->WriteInteger("Format1", FormatierungsDialog->ComboBox1->ItemIndex);
        Reg->WriteInteger("Format2", FormatierungsDialog->ComboBox2->ItemIndex);
        Reg->WriteInteger("Format3", FormatierungsDialog->ComboBox3->ItemIndex);
        Reg->WriteInteger("Format4", FormatierungsDialog->ComboBox4->ItemIndex);
        Reg->WriteInteger("Format5", FormatierungsDialog->ComboBox5->ItemIndex);
        Reg->WriteInteger("Format6", FormatierungsDialog->ComboBox6->ItemIndex);
        Reg->WriteInteger("Format7", FormatierungsDialog->ComboBox7->ItemIndex);
        Reg->WriteInteger("Format8", FormatierungsDialog->ComboBox8->ItemIndex);
        Reg->WriteInteger("Format9", FormatierungsDialog->ComboBox9->ItemIndex);
    }
  }
  __finally
  {
    Reg->CloseKey();
  }

    HauptFormular->TranslateToFrench();
    Francais->Enabled=false;
    English->Enabled=true;
    Deutsch->Enabled=true;
    Francais->Checked=false;

  try
  {
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if (Reg->OpenKey("\\Software\\TVC-Software\\BTOY\\Einstellungen", false))
    {
        FormatierungsDialog->ComboBox1->ItemIndex=Reg->ReadInteger("Format1");
        FormatierungsDialog->ComboBox2->ItemIndex=Reg->ReadInteger("Format2");
        FormatierungsDialog->ComboBox3->ItemIndex=Reg->ReadInteger("Format3");
        FormatierungsDialog->ComboBox4->ItemIndex=Reg->ReadInteger("Format4");
        FormatierungsDialog->ComboBox5->ItemIndex=Reg->ReadInteger("Format5");
        FormatierungsDialog->ComboBox6->ItemIndex=Reg->ReadInteger("Format6");
        FormatierungsDialog->ComboBox7->ItemIndex=Reg->ReadInteger("Format7");
        FormatierungsDialog->ComboBox8->ItemIndex=Reg->ReadInteger("Format8");
        FormatierungsDialog->ComboBox9->ItemIndex=Reg->ReadInteger("Format9");
    }
    else
    {
    }
  }
  __finally
  {
    delete Reg;
  }
}
//---------------------------------------------------------------------------

void __fastcall TOptionenDialog::MoveOverScanClick(TObject *Sender)
{
        OverScanDialog->Visible = true;
        OptionenDialog->SendToBack();
        OverScanDialog->BringToFront();
}
//---------------------------------------------------------------------------

