//---------------------------------------------------------------------------
#ifndef ID3SortH
#define ID3SortH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include "WrapGrid.h"
#include "Hauptprogramm.h"
#include <ExtCtrls.hpp>
#include "TFlatButtonUnit.hpp"
#include "AdvGrid.hpp"
#include "TFlatEditUnit.hpp"
#include "TFlatSpinEditUnit.hpp"
#include <Dialogs.hpp>
#include "TFlatHintUnit.hpp"
#include <jpeg.hpp>
#include "ScrollLabel.hpp"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TSortDialog : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TImage *Hintergrund;
    TFlatButton *FlatButton13;
    TAdvStringGrid *WrapGrid1;
    TFlatButton *FlatButton1;
    TFlatButton *FlatButton2;
    TFlatButton *FlatButton3;
    TFlatButton *FlatButton4;
    TFlatButton *FlatButton5;
    TLabel *YamakawaToolLabel;
    TFlatButton *SaveID3Tags;
    TFlatButton *FlatButton6;
    TFlatButton *FlatButton7;
    TFlatButton *FlatButton8;
    TLabel *Label1;
    TPopupMenu *PopupMenu;
    TMenuItem *InMP3Playabspielen1;
    TMenuItem *N1;
    TMenuItem *Kopieren1;
    TMenuItem *Ausschneiden1;
    TMenuItem *Einfgen1;
    TFlatButton *FlatButton9;
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall FlatButton13Click(TObject *Sender);
    void __fastcall FlatButtonClick(TObject *Sender);
    void __fastcall ArtistSort(TObject *Sender);
    void __fastcall TitleSort(TObject *Sender);
    void __fastcall AlbumSort(TObject *Sender);
    void __fastcall GenreSort(TObject *Sender);
    void __fastcall AfterSort(TObject *Sender);
    void __fastcall SaveID3TagsClick(TObject *Sender);
    void __fastcall CancelClick(TObject *Sender);
    void __fastcall YearSort(TObject *Sender);
    void __fastcall FileNameSort(TObject *Sender);
    void __fastcall WrapGrid1GetEditorType(TObject *Sender, int aCol,
          int aRow, TEditorType &aEditor);
    void __fastcall WrapGrid1DblClickCell(TObject *Sender, int Arow,
          int Acol);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall CopyClick(TObject *Sender);
    void __fastcall CutClick(TObject *Sender);
    void __fastcall PasteClick(TObject *Sender);
    void __fastcall InMP3Playabspielen1Click(TObject *Sender);
    void __fastcall Shuffle(TObject *Sender);
private:	// Anwenderdeklarationen
public:		// Anwenderdeklarationen
        int   FMoveX;
        int   FMoveY;
    __fastcall TSortDialog(TComponent* Owner);
      char* Concatenize;
      char* Concatenize2;
};
//---------------------------------------------------------------------------
extern PACKAGE TSortDialog *SortDialog;
//---------------------------------------------------------------------------
#endif
