//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Language.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TFlatButtonUnit"
#pragma link "TFlatCheckBoxUnit"
#pragma resource "*.dfm"
TSelectLanguage *SelectLanguage;
//---------------------------------------------------------------------------
__fastcall TSelectLanguage::TSelectLanguage(TComponent* Owner)
    : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 300, 200);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture2);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::DeutschClick(TObject *Sender)
{
    English->Checked=false;
    Francais->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::EnglishClick(TObject *Sender)
{
    Francais->Checked=false;
    Deutsch->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::FrancaisClick(TObject *Sender)
{
    English->Checked=false;
    Deutsch->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::FlatButton13Click(TObject *Sender)
{
    if(Deutsch->Checked)
    {
            OptionenDialog->Deutsch->Enabled=false;
            OptionenDialog->English->Enabled=true;
            OptionenDialog->Francais->Enabled=true;

            FormatierungsDialog->ComboBox1->ItemIndex=0;
            FormatierungsDialog->ComboBox2->ItemIndex=1;
            FormatierungsDialog->ComboBox3->ItemIndex=2;
            FormatierungsDialog->ComboBox4->ItemIndex=7;
            FormatierungsDialog->ComboBox5->ItemIndex=7;
            FormatierungsDialog->ComboBox6->ItemIndex=7;
            FormatierungsDialog->ComboBox7->ItemIndex=1;
            FormatierungsDialog->ComboBox8->ItemIndex=0;
            FormatierungsDialog->ComboBox9->ItemIndex=0;

            Close();
    }
    if(English->Checked)
    {
            OptionenDialog->Deutsch->Enabled=true;
            OptionenDialog->English->Enabled=false;
            OptionenDialog->Francais->Enabled=true;
            HauptFormular->TranslateToEnglish();
            Close();
    }
    if(Francais->Checked)
    {
            OptionenDialog->Deutsch->Enabled=true;
            OptionenDialog->English->Enabled=true;
            OptionenDialog->Francais->Enabled=false;
            HauptFormular->TranslateToFrench();
            Close();
    }
    else
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TSelectLanguage::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                SelectLanguage->Left = SelectLanguage->Left + ( X - FMoveX);
                SelectLanguage->Top = SelectLanguage->Top + ( Y - FMoveY);
                SelectLanguage->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------

