//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MP3DirChoose.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BrowseDlg"
#pragma link "TFlatButtonUnit"
#pragma link "TFlatEditUnit"
#pragma link "TFlatSpeedButtonUnit"
#pragma resource "*.dfm"
TDirectoryDialog *DirectoryDialog;
//---------------------------------------------------------------------------
__fastcall TDirectoryDialog::TDirectoryDialog(TComponent* Owner)
    : TForm(Owner)
{
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) & !WS_CAPTION);
      Height = ClientHeight;

      HRGN  Region;

      Region= CreateEllipticRgn(0, 0, 300, 200);
      SetWindowRgn(Handle, Region, TRUE);
      SelectObject(Handle, CreateSolidBrush(751684));

      Hintergrund->Picture->LoadFromFile(HauptFormular->bgpicture2);

      Paint();
      Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TDirectoryDialog::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        FMoveX = X;
        FMoveY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryDialog::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        if ((Shift == (TShiftState () << ssLeft)))
        {
                DirectoryDialog->Left = DirectoryDialog->Left + ( X - FMoveX);
                DirectoryDialog->Top = DirectoryDialog->Top + ( Y - FMoveY);
                DirectoryDialog->Perform ( WM_PAINT,0,0 );
                HauptFormular->Perform ( WM_PAINT,0,0 );
        }
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryDialog::FlatSpeedButton2Click(TObject *Sender)
{
        if(Zielverzeichnis->Text != NULL)
        {
                BrowseDlg1->InitialDir=Quellverzeichnis->Text;
        }
        else if(BrowseDlg1->FullPath != NULL)
        {
                BrowseDlg1->InitialDir=BrowseDlg1->FullPath;
        }
        BrowseDlg1->Execute();
        Quellverzeichnis->Text=BrowseDlg1->FullPath;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryDialog::FlatSpeedButton1Click(TObject *Sender)
{
        if(Zielverzeichnis->Text != NULL)
        {
                BrowseDlg2->InitialDir=Zielverzeichnis->Text;
        }
        else if(BrowseDlg2->FullPath != NULL)
        {
                BrowseDlg2->InitialDir=BrowseDlg2->FullPath;
        }
        BrowseDlg2->Execute();
        Zielverzeichnis->Text=BrowseDlg2->FullPath;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryDialog::FlatButton13Click(TObject *Sender)
{
    if (DirectoryExists(Quellverzeichnis->Text))
    {
        if (DirectoryExists(Zielverzeichnis->Text))
        {
            HauptFormular->shuffledlist=false;
            HauptFormular->mp3path=Quellverzeichnis->Text.c_str();
            HauptFormular->copypath=Zielverzeichnis->Text.c_str();
            HauptFormular->mp3dir=Quellverzeichnis->Text.c_str();
            HauptFormular->ID3TagAuslesen();
            HauptFormular->VorschauButtonClick(Sender);
            Close();
        }
        else
        {
            if (!CreateDir(Zielverzeichnis->Text))
                ShowMessage("Verzeichnis kann nicht erstellt werden.");
            HauptFormular->shuffledlist=false;
            HauptFormular->mp3path=Quellverzeichnis->Text.c_str();
            HauptFormular->copypath=Zielverzeichnis->Text.c_str();
            HauptFormular->mp3dir=Quellverzeichnis->Text.c_str();
            HauptFormular->ID3TagAuslesen();
            HauptFormular->VorschauButtonClick(Sender);
            Close();
        }
    }
}
//---------------------------------------------------------------------------
